# Guile bindings for GNU Gettext's libgettextpo.
# Copyright © 2019 Miguel Ángel Arruga Vivas <rosen644835@gmail.com>
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This software is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software.  If not, see <http://www.gnu.org/licenses/>.

AM_GUILDFLAGS =				\
	--load-path="$(top_builddir)"	\
	--load-path="$(top_srcdir)"	\
	--warn="unbound-variable"	\
	--warn="unused-variable"	\
	--warn="arity-mismatch"		\
	--warn="format"			\
	$(LIBGETTEXTPO_GUILDFLAGS)

nobase_dist_guilemodule_DATA =	\
	%D%/po/check.scm	\
	%D%/po/error.scm	\
	%D%/po/file.scm		\
	%D%/po/filepos.scm	\
	%D%/po/format.scm	\
	%D%/po/header.scm	\
	%D%/po/internal-api.scm	\
	%D%/po/iterator.scm	\
	%D%/po/message.scm	\
	%D%/po.scm

EXTRA_DIST += %D%/po/config.scm.in
BUILT_SOURCES += %D%/po/config.scm
nobase_nodist_guilemodule_DATA = %D%/po/config.scm
nobase_nodist_guileobject_DATA = $(nobase_dist_guilemodule_DATA:%.scm=%.go)

CLEANFILES +=					\
	$(nobase_nodist_guileobject_DATA)	\
	%D%/po/config.scm			\
	%D%/po/config.scm-to-install		\
	%D%/po/config.go

# Go compilation
.scm.go:
	$(AM_V_GUILD)$(PRE_INST_ENV) $(GUILD) compile $(AM_GUILDFLAGS)	\
	  $(GUILDFLAGS) -o "$@" "$<" $(AM_V_GUILD_FILTER)

SUFFIXES += .go

uninstalled_libs = $(abs_top_builddir)/src
%D%/po/config.scm: $(srcdir)/%D%/po/config.scm.in $(guileextension_LTLIBRARIES)
	$(AM_V_GEN)$(MKDIR_P) %D%/po && \
	  $(SED) -e 's,[@]extensiondir@,$(uninstalled_libs),'		\
	    -e 's,[@]LIBGETTEXTPO_LIBDIR@,$(LIBGETTEXTPO_LIBDIR),'	\
	    -e 's,[@]PACKAGE_VERSION@,$(PACKAGE_VERSION) (uninst.),'	\
	    -e 's,[@]PACKAGE_NAME@,$(PACKAGE_NAME),'			\
	    "$<" > "$@"

%D%/po/config.scm-to-install: $(srcdir)/%D%/po/config.scm.in $(guileextension_LTLIBRARIES)
	$(AM_V_GEN)$(SED) -e 's,[@]extensiondir@,$(guileextensiondir),'	\
	  -e 's,[@]LIBGETTEXTPO_LIBDIR@,$(LIBGETTEXTPO_LIBDIR),'	\
	  -e 's,[@]PACKAGE_VERSION@,$(PACKAGE_VERSION),'		\
	  -e 's,[@]PACKAGE_NAME@,$(PACKAGE_NAME),'			\
	  "$<" > "$@"

.PHONY: prepare-config.scm compile-config.go

prepare-config.scm: %D%/po/config.scm-to-install
	mv %D%/po/config.scm %D%/po/config.scm-uninstalled
	cp -p %D%/po/config.scm-to-install %D%/po/config.scm

compile-config.go: prepare-config.scm
	$(PRE_INST_ENV) $(GUILD) compile $(AM_GUILDFLAGS) \
		$(GUILDFLAGS) -o %D%/po/config.go %D%/po/config.scm

hack_install_go_files = install-nobase_nodist_guileobjectDATA
$(hack_install_go_files): install-nobase_dist_guilemoduleDATA

install-data-hook: compile-config.go
	$(INSTALL) %D%/po/config.scm \
	  "$(DESTDIR)$(guilemoduledir)/%D%/po/config.scm"
	$(INSTALL) %D%/po/config.go \
	    "$(DESTDIR)$(guileobjectdir)/%D%/po/config.go"
	mv %D%/po/config.scm-uninstalled %D%/po/config.scm
	rm -f %D%/po/config.go

uninstall-hook:
	rm -f "$(DESTDIR)$(guileobjectdir)/%D%/po/config.go"
