# Guile bindings for GNU Gettext's libgettextpo.
# Copyright © 2019 Miguel Ángel Arruga Vivas <rosen644835@gmail.com>
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This software is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software.  If not, see <http://www.gnu.org/licenses/>.

# serial 1 guile-gettextpo.m4

AC_DEFUN([GUILE_GETTEXTPO_CHECK_GETTEXTPO],
[# TODO Better checks
gettext_path=check
gettext_libdir=
gettext_includedir=

AC_ARG_WITH([gettext-prefix],
            [AS_HELP_STRING([--with-gettext-prefix=PATH],
                            [Prefix from gettext installation])],
            [gettext_path=$withval],
            [gettext_path=check])

AC_ARG_WITH([gettext-includedir],
            [AS_HELP_STRING([--with-gettext-includedir=PATH],
                            [includedir from gettext installation])],
            [gettext_includedir=$withval],
            [gettext_includedir=auto])

AC_ARG_WITH([gettext-libdir],
            [AS_HELP_STRING([--with-gettext-libdir=PATH],
                            [libdir from gettext installation])],
            [gettext_libdir=$withval],
            [gettext_libdir=auto])

libpaths="$LIBRARY_PATH:$LD_LIBRARY_PATH:/usr/local/lib:/lib:/usr/lib"
if test "x$gettext_path" = "xcheck"; then
    for i in `echo "$libpaths" | tr ":" " "`; do
        if test "x$gettext_path" = "xcheck" && test -e "$i/libgettextpo.la"; then
            # FIXME: This is really wrong.
            libtool_libdir=`( . $i/libgettextpo.la && echo $libdir )`
            gettext_path=`dirname $gettext_libdir`
            if test "x$gettext_libdir" = "xauto"; then
                gettext_libdir="$libtool_libdir"
            fi
        fi
    done
fi

if test "x$gettext_path" = "xcheck"; then
    for i in `echo "$libpaths" | tr ":" " "`; do
        if test "x$gettext_path" = "xcheck" && test -e "$i/libgettextpo.so"; then
            found_libdir=$i
            gettext_path=`dirname $i`
            if test "x$gettext_libdir" = "xauto"; then
                gettext_libdir="$found_libdir"
            fi
        fi
    done
fi

AS_IF([test "x$gettext_path" = "xcheck"],
      [AC_MSG_ERROR([Unable to find libgettextpo])])
AS_IF([test "x$gettext_libdir" = "xauto"],
      [gettext_libdir=$gettext_path/lib])
AS_IF([test "x$gettext_includedir" = "xauto"],
      [gettext_includedir=$gettext_path/include])

LIBGETTEXTPO_CPPFLAGS="-I$gettext_includedir"
LIBGETTEXTPO_LIBS="-L$gettext_libdir -lgettextpo"
LIBGETTEXTPO_LTLIBS="$gettext_libdir/libgettextpo.la"
LIBGETTEXTPO_LIBDIR="$gettext_libdir"
AC_SUBST([LIBGETTEXTPO_CPPFLAGS])
AC_SUBST([LIBGETTEXTPO_LIBS])
AC_SUBST([LIBGETTEXTPO_LTLIBS])
AC_SUBST([LIBGETTEXTPO_LIBDIR])
])
