# Guile bindings for GNU Gettext's libgettextpo.
# Copyright © 2019 Miguel Ángel Arruga Vivas <rosen644835@gmail.com>
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This software is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software.  If not, see <http://www.gnu.org/licenses/>.

EXTENSION_DIR = %D%

EXTENSION_CPPFLAGS =			\
	$(LIBGETTEXTPO_CPPFLAGS)	\
	-I$(EXTENSION_DIR)/		\
	-I$(srcdir)/$(EXTENSION_DIR)/

EXTENSION_CFLAGS = $(GUILE_CFLAGS)

guileextension_LTLIBRARIES = %D%/libgettextpo_guile.la
%C%_libgettextpo_guile_la_SOURCES = %D%/extension.c %D%/extension.x
%C%_libgettextpo_guile_la_CPPFLAGS = $(EXTENSION_CPPFLAGS)
%C%_libgettextpo_guile_la_CFLAGS = $(EXTENSION_CFLAGS)
%C%_libgettextpo_guile_la_LIBADD = $(LIBGETTEXTPO_LTLIBS) $(GUILE_LTLIBS)
%C%_libgettextpo_guile_la_LDFLAGS = -export-dynamic -module

EXTRA_DIST += %D%/extension.c.in
CLEANFILES += %D%/extension.x

snarfcppopts = $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS) \
	$(EXTENSION_CPPFLAGS) $(EXTENSION_CFLAGS)
%D%/extension.c %D%/extension.x: $(srcdir)/%D%/extension.c.in
	@echo "  GEN	" %D%/extension.c; cp "$<" %D%/extension.c
	@echo "  SNARF	" %D%/extension.x; guile-snarf -o %D%/extension.x \
	  %D%/extension.c $(snarfcppopts)
