# -*- mode: shell-script; -*-
# Guile bindings for GNU Gettext's libgettextpo.
# Copyright © 2019 Miguel Ángel Arruga Vivas <rosen644835@gmail.com>
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This software is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software.  If not, see <http://www.gnu.org/licenses/>.

# Print library version
version=`$GUILE -c '(display (@ (gettext po) gettext-po-version))'`
test -n "$version" && echo "$version"

format_file="$tests_data_dir/t-formats.scm"
out="$format_file"
test -z "$BASH" || trap 'rm -f $out' EXIT

pwd
cat > "$format_file" <<EOF
(use-modules (gettext po))
(let ((formats (po-format-list)))
  (if (and formats (list? formats) (> (length formats) 0))
      (let loop ((current formats))
          (if (pair? current)
              (begin (display (car current)) (newline) (loop (cdr current)))
              (newline)))
      (display "nok")))
EOF

scm_format="`$GUILE -s "$format_file" | fgrep scheme-format`"
test "x$scm_format" != "xnok"

lisp_format="`$GUILE -s "$format_file" | fgrep lisp-format`"
test "x$lisp_format" != "xnok"

rm -f $out
