# Guile bindings for GNU Gettext's libgettextpo.
# Copyright © 2019 Miguel Ángel Arruga Vivas <rosen644835@gmail.com>
#
# This is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This software is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software.  If not, see <http://www.gnu.org/licenses/>.

TEST_EXTENSIONS = .sh .scm

tests_data_directory = %D%/data
EXTRA_TEST_DATA_FILES =			\
	%D%/data/bad-po-format.po	\
	%D%/data/bad-scheme-format.po	\
	%D%/data/complete.po		\
	%D%/data/fuzzy.po		\
	%D%/data/template.po

SCM_TESTS =			\
	%D%/errors.scm		\
	%D%/iteration.scm	\
	%D%/manual.scm		\
	%D%/read.scm		\
	%D%/write.scm

SH_TESTS = %D%/basic.sh

SCM_LOG_DRIVER =					\
	$(top_builddir)/test-env			\
	  $(GUILE) --no-auto-compile -e main		\
	  $(top_srcdir)/build-aux/test-driver.scm

AM_SCM_LOG_DRIVER_FLAGS = --brief=yes

SH_LOG_COMPILER = $(top_builddir)/test-env $(SHELL)
AM_SH_LOG_FLAGS = -x -e

AM_TESTS_ENVIRONMENT =					\
	abs_top_srcdir="$(abs_top_srcdir)"		\
	tests_data_dir="$(tests_data_directory)"	\
	GUILE_AUTO_COMPILE=0				\
	GUILE="$(GUILE)"

TESTS = $(SH_TESTS) $(SCM_TESTS)
EXTRA_DIST += $(TESTS) $(EXTRA_TEST_DATA_FILES)

.PHONY: make_data_directory
$(SH_TESTS) $(SCM_TESTS): make_data_directory $(EXTRA_TEST_DATA_FILES)

# XXX: Needed for separate build folder
make_data_directory:
	$(MKDIR_P) $(tests_data_directory)
